require "scripts/loadlevel.lua"
require "scripts/gameplay.lua"

function love.load()
	--load images
	image_spikeball=love.graphics.newImage("images/spikeball.png")
	
	--filesystem stuff
	love.filesystem.setIdentity("tesselode_tilt")
	love.filesystem.mkdir("custom")
	
	--start on level select screen
	screen="levelselect"
	levelselect_string=""
end

function love.update()
	if screen=="gameplay" then
		gameplay_update()
	end
end

function love.keypressed(key)
	if screen=="levelselect" then --level name typing
		if key=="backspace" then
			if string.len(levelselect_string)>1 then
				levelselect_string=string.sub(levelselect_string,1,string.len(levelselect_string)-1)
			else
				levelselect_string=""
			end
		elseif key=="return" then
			loadlevel("custom/"..levelselect_string..".tilt")
			createlevel()
			gameplay_load()
			screen="gameplay"
		else
			levelselect_string=levelselect_string..key
		end
	end

	if screen=="gameplay" then
		if key=="f5" then
			createlevel()
			gameplay_load()
		end
	end
end

function love.draw()
	if screen=="levelselect" then --level select screen drawing
		love.graphics.setColor(255,255,255,255)
		love.graphics.setFont("images/Eurosti.TTF",20)
		love.graphics.printf("Type in the name of the level to load, then press enter",0,love.graphics.getHeight()/3,love.graphics.getWidth(),"center")
		love.graphics.printf(levelselect_string,0,love.graphics.getHeight()/1.5,love.graphics.getWidth(),"center")
	end
	
	if screen=="gameplay" then
		gameplay_draw()
		love.graphics.setColor(255,255,255,255)
		love.graphics.setFont("images/Eurosti.TTF",15)
		love.graphics.print("Press F5 to restart",50,50)
	end
end