function gameplay_load()
	mousex=love.mouse.getX() --variables for tracking mouse movement
	mousey=love.mouse.getY()
	mousex_previous=love.mouse.getX()
	mousey_previous=love.mouse.getY()
	
	world:setAllowSleep(false)
	world:setCallbacks(collision_new,collision_persist,collision_end,collision_result)
end

function gameplay_update()
	mousex_previous=mousex --track mouse movement
	mousey_previous=mousey
	mousex=love.mouse.getX() 
	mousey=love.mouse.getY()

	local a --rotate platforms
	for a=1,objectnum-1 do
		if object[a].kind=="platform" then
			if platform_active[a]==1 and love.mouse.isDown("l") then
				platform[a]:setAngularVelocity((math.rad(((mousex-mousex_previous)+(mousey-mousey_previous))/3))/love.timer.getDelta())
			else
				platform[a]:setAngularVelocity(0)
			end
		end
	end
	
	local x,y=ball:getLinearVelocity() --limit ball speed
	if x>400 then ball:setLinearVelocity(400,y) end
	if x<-400 then ball:setLinearVelocity(-400,y) end
	if y>500 then ball:setLinearVelocity(x,500) end
	if y<-500 then ball:setLinearVelocity(x,-500) end
	
	if ball:getY()>love.graphics.getHeight() then --check if ball falls of bottom of screen
		createlevel()
		gameplay_load()
	end
	
	if ball:getX()<0 then --check if ball goes past left edge of screen
		createlevel()
		gameplay_load()
	end
	
	if ball:getX()>love.graphics.getWidth() then --same for right edge
		createlevel()
		gameplay_load()
	end
	
	world:update(love.timer.getDelta())
end

function collision_new(first,second,contact)
	if first=="goal" and second=="ball" then --check if ball meets goal
		createlevel()
		gameplay_load()
	end
	
	if first=="ball" and second=="spike" then --check if ball hits spikes
		createlevel()
		gameplay_load()
	end
	
	local a, b --activate platforms when ball touches them
	for a=1,objectnum-1 do
		if first=="platform"..tostring(a) and second=="ball" then
			for b=1,objectnum-1 do
				platform_active[b]=0
			end
			platform_active[a]=1
		end
	end
end

function gameplay_draw() --draw physics stuff
	local a, b
	for a=1,objectnum-1 do
		if object[a].kind=="ball" then --draw ball
			love.graphics.setColor(255,255,255,255)
			love.graphics.circle("fill",ball:getX(),ball:getY(),ball_shape:getRadius(),16)
		end
		
		if object[a].kind=="goal" then --draw goal
			love.graphics.setColor(0,255,0,255)
			love.graphics.rectangle("fill",goal:getX()-16,goal:getY()-16,32,32)
		end
		
		if object[a].kind=="wall" then --draw wall
			love.graphics.setColor(128,128,128,255)
			love.graphics.rectangle("fill",wall[a]:getX()-16,wall[a]:getY()-16,32,32)
		end
		
		if object[a].kind=="spike" then --draw spikeballs
			love.graphics.setColor(255,255,255,255)
			love.graphics.draw(image_spikeball,spike[a]:getX()-16,spike[a]:getY()-16)
		end
		
		if object[a].kind=="platform" then --draw platform shapes
			if platform_active[a]==1 then
				love.graphics.setColor(255,0,0,255)
			else
				love.graphics.setColor(255,255,255,255)
			end
			
			for b=1,shape_amount[a] do
				love.graphics.polygon("fill",platform_shape[a][b]:getPoints())
			end
		end
	end
end